SoVRMLShape(3)

NAME
SoVRMLShape - The SoVRMLShape class holds geometry and geometry appearance nodes.

SYNOPSIS

#include <Inventor/VRMLnodes/SoVRMLShape.h>

Inherits SoNode.

  Public Types
enum CacheEnabled { OFF, ON, AUTO }

  Public Member Functions
virtual SoType getTypeId (void) const
virtual SbBool affectsState (void) const
virtual void doAction (SoAction *action)
virtual void callback (SoCallbackAction *action)
virtual void GLRender (SoGLRenderAction *action)
virtual void getBoundingBox (SoGetBoundingBoxAction *action)
virtual void rayPick (SoRayPickAction *action)
virtual void search (SoSearchAction *action)
virtual void write (SoWriteAction *action)
virtual void getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual SoChildList * getChildren (void) const
virtual void notify (SoNotList *list)
virtual void copyContents (const SoFieldContainer *from, SbBool copyConn)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)
static void setNumRenderCaches (int num)
static int getNumRenderCaches (void)

  Public Attributes
SoSFNode appearance
SoSFNode geometry
SoSFEnum renderCaching
SoSFEnum boundingBoxCaching

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoVRMLShape class holds geometry and geometry appearance nodes. The detailed class documentation is taken verbatim from the VRML97 standard (ISO/IEC 14772-1:1997). It is copyright The Web3D Consortium, and is used by permission of the Consortium:

Shape {
  exposedField SFNode appearance NULL
  exposedField SFNode geometry   NULL
}

The Shape node has two fields, appearance and geometry, which are used to create rendered objects in the world. The appearance field contains an SoVRMLAppearance node that specifies the visual attributes (e.g., material and texture) to be applied to the geometry. The geometry field contains a geometry node. The specified geometry node is rendered with the specified appearance nodes applied. See 4.6.3, Shapes and geometry (http://www.web3d.org/documents/specifications/14772/V2.0/part1/concepts.html#4.6.3), and SoVRMLAppearance, for more information.

4.14, Lighting model (http://www.web3d.org/documents/specifications/14772/V2.0/part1/concepts.html#4.14), contains details of the VRML lighting model and the interaction between Appearance nodes and geometry nodes. If the geometry field is NULL, the object is not drawn.

Member Enumeration Documentation

  enum SoVRMLShape::CacheEnabled
Used to enumerate cache strategies.

Enumerator

OFF Never cache

ON  Always cache

AUTO
    Use heuristics to try to figure out the optimal caching policy.

Member Function Documentation

  SoType SoVRMLShape::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoVRMLShape::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Implements SoBase.

  const SoFieldData ** SoVRMLShape::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoVRMLShape::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoFieldContainer.

  void SoVRMLShape::initClass (void) [static]

  SbBool SoVRMLShape::affectsState (void) const [virtual]
Returns TRUE if the node could have any effect on the state during traversal.

If it returns FALSE, no data in the traversal state will change from the pre-traversal state to the post-traversal state. The SoSeparator node will for instance return FALSE, as it pushes and pops the state before and after traversal of its children. All SoShape nodes will also return FALSE, as just pushing out geometry data to the rendering engine won't affect the actual rendering state.

The default method returns TRUE, on a 'better safe than sorry' philosophy.

Reimplemented from SoNode.

  void SoVRMLShape::doAction (SoAction * action) [virtual]
This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

  void SoVRMLShape::callback (SoCallbackAction * action) [virtual]
Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

  void SoVRMLShape::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoNode.

  void SoVRMLShape::getBoundingBox (SoGetBoundingBoxAction * action) [virtual]
Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculate their bounding box also override this method to change the relevant state variables.

Reimplemented from SoNode.

  void SoVRMLShape::rayPick (SoRayPickAction * action) [virtual]
Action method for SoRayPickAction.

Checks the ray specification of the action and tests for intersection with the data of the node.

Nodes influencing relevant state variables for how picking is done also override this method.

Reimplemented from SoNode.

  void SoVRMLShape::search (SoSearchAction * action) [virtual]
Action method for SoSearchAction.

Compares the search criteria from the action to see if this node is a match. Searching is done by matching up all criteria set up in the SoSearchAction -- if any of the requested criteria is a miss, the search is not deemed successful for the node.

See also
    SoSearchAction

Reimplemented from SoNode.

  void SoVRMLShape::write (SoWriteAction * action) [virtual]
Action method for SoWriteAction.

Writes out a node object, and any connected nodes, engines etc, if necessary.

Reimplemented from SoNode.

  void SoVRMLShape::getPrimitiveCount (SoGetPrimitiveCountAction * action) [virtual]
Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculate their primitive count also override this method to change the relevant state variables.

Reimplemented from SoNode.

  SoChildList * SoVRMLShape::getChildren (void) const [virtual]
Returns list of children for this node.

Reimplemented from SoNode.

  void SoVRMLShape::notify (SoNotList * l) [virtual]
Notifies all auditors for this instance when changes are made.

Reimplemented from SoNode.

  void SoVRMLShape::copyContents (const SoFieldContainer * from, SbBool copyconnections) [virtual]
Makes a deep copy of all data of from into this instance, except external scene graph references if copyconnections is FALSE.

This is the method that should be overridden by extension node / engine / dragger / whatever subclasses which need to account for internal data that are not handled automatically.

For copying nodes from application code, you should not invoke this function directly, but rather call the SoNode::copy() function:

SoNode * mynewnode = templatenode->copy();

The same also goes for engines.

Make sure that when you override the copyContents() method in your extension class that you also make it call upwards to its parent superclass in the inheritance hierarchy, as copyContents() in for instance SoNode and SoFieldContainer does important work. It should go something like this:

void
MyCoinExtensionNode::copyContents(const SoFieldContainer * from,
                                  SbBool copyconnections)
{
  // let parent superclasses do their thing (copy fields, copy
  // instance name, etc.)
  SoNode::copyContents(from, copyconnections);
  // [..then copy internal data..]
}

Reimplemented from SoNode.

Member Data Documentation

  SoSFNode SoVRMLShape::appearance
Can store an SoVRMLAppearance node, or NULL.

  SoSFNode SoVRMLShape::geometry
Can store any SoVRMLGeometry subclass, or NULL.

  SoSFEnum SoVRMLShape::renderCaching
Render caching strategy. Default value is AUTO.

  SoSFEnum SoVRMLShape::boundingBoxCaching
Bounding box caching strategy. Default value is AUTO.

Author

Generated automatically by Doxygen for Coin from the source code.